rollLogs = {};

-- 3 columns: Partner 1, Partner 2, who rolled last
-- ex: battles[1] = {"Rak", "Bros", "Rak"};
battles = {};
testingHemet = true;







SLASH_DEATHROLLOFFORTUNE1 = '/DeathrollOfFortune';
function SlashCmdList.DEATHROLLOFFORTUNE(msg)
	Deathroll();
end

-- When the user want to deathroll
function Deathroll()
	local playerName = GetUnitName("player");	

	if (playerName ~= nil) then
	
		SetPartners(playerName);
		local key, opponent = findBattle(playerName);
		
		-- If battles found
		if (key ~= -1) then
			-- skip if player was the last to roll
			if (playerName ~= battles[key][3]) then
				RandomRoll(1, rollLogs[opponent]);
			else
				print("Waiting for the opponent to roll");		
			end
		else
			print("No opponent found");
		end
		
	else
		print("Cannot find player name");
	end
end

function DeathrollOfFortune_EventHandler(event)

	if (event == "ADDON_LOADED") then
		DeathrollOfFortuneAll:UnregisterEvent("ADDON_LOADED");
		DeathrollOfFortuneAll:RegisterEvent("CHAT_MSG_SYSTEM");
	end	
	
	DeathrollOfFortuneAll:SetScript("OnEvent", function(self, event, ...)
		if event == "CHAT_MSG_SYSTEM" then
			local message = ...;
			local author, rollResult, rollMin, rollMax = string.match(message, "(.+) rolls (%d+) %((%d+)-(%d+)%)")
			
			SaveRoll(author, rollResult, rollMin, rollMax);	
			SetPartners(author);
			ValidateEnding(author, rollResult);
			ShowMatches();
		end
	end)
end

-- Return: index, opponent
function findBattle(character)
	for key, person in pairs(battles) do
		if (character == person[1]) then
			return key, person[2];
		elseif (character == person[2]) then
			return key, person[1];
		end
	end
	return -1, -1;
end

function SetPartners(character)
	local i, o = findBattle(character);
	
	-- If not already matched
	if (i == -1) then
		-- Get new index
		local count = 0;
		for key, person in pairs(battles) do
			count = count + 1;
		end
		local newIndex = tostring(count + 1);
		
		-- Search if somebody is still unmatched and create a new slot if found
		for key, value in pairs(rollLogs) do
			if (key ~= character and rollLogs[key] ~= nil) then
				
				local k, opponent = findBattle(key);
				if (k == -1) then
					battles[newIndex] = {character, key, ""}
				end
			end
		end
	end
end




function SaveRoll(author, rollResult, rollMin, rollMax)
	if (author ~= nil and rollMin == "1") then
	--if (author ~= nil) then  --To test the roll 100-100
	
		local key, opponent = findBattle(author);
		
		-- If battles found
		if (key ~= -1) then

			-- dont save if author was the last to roll
			if (author ~= battles[key][3]) then		

				-- Cant start a deathroll with a /roll 1-100 (conflicts with the roll on items)
				-- Unless its opponent rolled a 100 during the deathroll match
				if (rollMax == "100") then					
					if (rollLogs[opponent] == "100") then
						rollLogs[author] = rollResult;
						battles[key][3] = author;
					end
				else
					rollLogs[author] = rollResult;
					battles[key][3] = author;
				end
			end
		else
			-- Cant start a deathroll with a /roll 1-100 (conflicts with the roll on items)
			if (rollMax ~= "100") then
				rollLogs[author] = rollResult;
			end
		end
	end
end


function ValidateEnding(author, rollResult)

	-- Gambling will end
	if (rollResult == "1") then
		local key, opponent = findBattle(author);
		if (key ~= -1) then
			-- If player participated the match
			local playerName = GetUnitName("player");
			if (opponent == playerName) then
				local msg = "I WIN!! " .. author .. ", you need to give me my money!";
				SendChatMessage(msg, "YELL");
			end
			
			-- End the match
			ResetPartner(key, author, opponent);
		
		else
			print("A match ended, but no partner were found");
		end		
	end
end


function ShowMatches()
	local first = true;
	local textToAdd = "";
	for key, person in pairs(battles) do
		if (first == true) then
			textToAdd = person[1] .. " vs " .. person[2];
			first = false;
		else
			textToAdd = textToAdd .. [[ 
]] .. person[1] .. " vs " .. person[2];
		end
	end
	DeathrollOfFortuneFrameBottomRightLabel:SetText(textToAdd);
end


function ResetPartner(key, character, opponent)
	rollLogs[character] = nil;
	rollLogs[opponent] = nil;
	battles[key] = nil;
end

function Roll_OnClick()
	Deathroll();
end


function Reset_OnClick()
	DeathrollOfFortuneFrameName:SetText("");	
	rollLogs = {};
	battles = {};
	testingHemet = true;
end


-- TESTING FUNCTIONS
function TestNat_OnClick()	
	testRoll("Nat Pagle", false);
end
function TestHemet_OnClick()	
	testRoll("Hemet Nesingwary", testingHemet);
	testingHemet = false;
end
function TestLeroy_OnClick()	
	testRoll("Leroy Jenkins", false);
end
function testRoll(c, startRoll)
	if (startRoll == false) then
		SetPartners(c);
		local key, opponent = findBattle(c);
		if (key ~= -1) then
			if (c ~= battles[key][3]) then
				local rollResult = tostring(math.random(1, rollLogs[opponent]))
				--local rollResult = "100"; -- test case
				SaveRoll(c, rollResult, "1", rollLogs[opponent]);
				print(rollResult);
				ValidateEnding(c, rollResult);
				ShowMatches();
			end
		else
			print("No opponent found")
		end
	else
		local rollResult = "199999";
		SaveRoll(c, rollResult, "1", rollLogs[opponent]);
		print(rollResult);
	end
end











